Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## ix.iview.domain
Class UIRefinement

    java.lang.Object
      ix.iview.domain.UIRefinement

All Implemented Interfaces:
  Named, SchemaTerms, EditableObject, UIEditableObject, UIObject, javax.swing.tree.TreeNode

    public class UIRefinement

extends java.lang.Object
implements UIObject, Named, SchemaTerms, javax.swing.tree.TreeNode

Mirrors the domain's Refinement and adds UI, Graph, and TreeNode things

Nested Class Summary
`class` | `UIRefinement.ConstraintTypeException`
`class` | `UIRefinement.NodeTypeException`

Field Summary
`Annotations` | `annotations`
`protected java.util.List` | `autoPoints`
`protected Refinement` | `baseObject`
`protected java.lang.String` | `baseReference`
`java.lang.String` | `comments`
`java.util.List` | `constraints`
`protected IGraph` | `graph` name of the original refinement
`java.util.List` | `issues`
`java.lang.String` | `name`
`java.util.List` | `nodes`
`java.util.List` | `orderings`
`LList` | `pattern`
`protected UIDomain` | `uiDomain`
`java.util.List` | `variableDeclarations`

Fields inherited from interface ix.icore.domain.SchemaTerms
`O_NONE, O_OTHER, O_PARALLEL, O_SEQUENCE`

Constructor Summary
`UIRefinement(UIDomain uiDomain)`
`UIRefinement(UIDomain uiDomain, Refinement original)`

Method Summary
`void` | `addConstraint(java.lang.Object newValue)`
`void` | `addDataChangeListener(DataChangeListener l)`
`void` | `addIssue(Issue issue)`
`void` | `addNode(NodeSpec node)`
`void` | `addOrdering(Constraint newValue)`
`void` | `addOrdering(Ordering newValue)`
`void` | `addToDomain()`
`void` | `addToDomain(Domain domain)` Adds the contents of this UIObject to the domain (part of publish).
`void` | `checkConsistency()`
`java.util.Enumeration` | `children()`
`void` | `clearConstraints()`
`void` | `clearIssues()`
`void` | `clearNodes()`
`void` | `clearOrderings()`
`void` | `clearPattern()`
`UIRefinement` | `cloneThis()`
`java.util.List` | `collectChanges()` Collects the differences between this object and the base one.
`java.util.List` | `collectChanges(Refinement original)` Collects the differences between this object and the given one.
`java.util.List` | `collectChanges(Refinement original, java.lang.String which)`
`java.util.List` | `collectChangesFromOriginal()` Collects the differences between this object and the base one.
`static boolean` | `constraintMentionsNode(Constraint c, Name nodeId)`
`static boolean` | `constraintMentionsNode(Ordering o, Name nodeId)`
`boolean` | `deleteConstraint(Constraint c)` Removes the given constraint;
`void` | `deleteIssue(Issue issue)`
`void` | `deleteNode(NodeSpec node)`
`protected void` | `deleteNodeConstraints(NodeSpec node)`
`static java.util.List` | `filterForConditions(java.util.List constraints)` Gets the list of conditions and effects that are in the constraints.
`static java.util.List` | `filterForVariable(ItemVar var, java.util.List constraints)` Searches the given constraints for ones that constrain the variable, i.e. pattern assignments that have the variable as their subject.
`static NodeSpec` | `findEditedNode(java.util.List oldNodes, LList pattern)` Tries to find a node in the given list with a similar pattern.
`NodeSpec` | `findNode(java.util.List nodeList, LList pattern)` Tries to find a node in the given list whose pattern matches the given pattern.
`NodeSpec` | `findNode(LList pattern)` Tries to find a node within this refinement whose pattern matches the given pattern.
`NodeSpec` | `findNode(Name id)`
`boolean` | `getAllowsChildren()`
`Annotations` | `getAnnotations()`
`java.lang.Class` | `getBaseClass()` Gets the class of objects that can represent this one in the domain.
`IXObject` | `getBaseObject()` Gets the object that corresponds to this one in the domain.
`java.lang.Object` | `getBaseReference()` Gets the Id that can be used to identify the base object in the domain.
`javax.swing.tree.TreeNode` | `getChildAt(int index)`
`int` | `getChildCount()`
`java.lang.String` | `getComments()`
`java.util.List` | `getConditions()`
`java.util.List` | `getConstraints()`
`Domain` | `getDomain()` Gets the base domain.
`IGraph` | `getGraph()`
`Name` | `getHighestNodeId()`
`static Name` | `getHighestNodeId(java.util.List nodes)`
`int` | `getIndex(javax.swing.tree.TreeNode node)`
`java.util.List` | `getIssues()`
`java.lang.String` | `getName()`
`Name` | `getNewNodeId()`
`java.util.List` | `getNodes()`
`java.util.List` | `getOrderings()`
`java.lang.String` | `getOrderingType()` Gets the refinement's ordering type (none, parallel, sequence, other).
`java.lang.String` | `getOrderingType(java.util.Collection orderings)`
`IXObject` | `getOriginal()` Gets the object that corresponds to this one in the original domain.
`java.util.List` | `getOtherConstraints()`
`javax.swing.tree.TreeNode` | `getParent()`
`LList` | `getPattern()`
`Constraint` | `getTypeConstraint(ItemVar var)`
`java.util.List` | `getTypeConstraints()`
`UIDomain` | `getUIDomain()` Gets the ui domain of which this object is part.
`java.util.List` | `getVariableConstraints(ItemVar var)` Find all (world-state) constraints that have the given variable in them.
`java.util.List` | `getVariableDeclarations()`
`java.util.SortedSet` | `getVariablesUsed()`
`IGraph` | `graphFromPosition(Refinement refinement, java.lang.Object pos)`
`boolean` | `hasAnonConstraints()`
`boolean` | `hasChanged()` Finds out whether the refinement has changed from the base-object (i.e. since the object was last saved to draft).
`boolean` | `hasChanged(Refinement original)` Finds out whether the refinement has changed from the given object.
`boolean` | `hasChangedFromOriginal()` Finds out whether the refinement has changed from the original.
`boolean` | `hasChangedNoDebug(Refinement original)` Finds out whether the refinement has changed from the given object.
`boolean` | `hasConditions()`
`boolean` | `hasOrderings()`
`boolean` | `hasOriginal()` Determines whether the object has an original in the base domain.
`boolean` | `isEmpty()` A refinement is empty if all its data fields are empty.
`boolean` | `isEmpty(Refinement refinement)` A refinement is empty if all its data fields are empty.
`boolean` | `isLeaf()`
`static boolean` | `isRef(NodeSpec node, java.lang.Object o)` Check whether the given object is a reference to the given node.
`boolean` | `isUndefined()` A refinement is undefined if all its data fields are empty except the pattern which may have data in it.
`void` | `loadCanvasPositionGraphFromDomain(Refinement refinement)`
`void` | `loadFromDomain()` Loads this object from its baseObject.
`void` | `loadFromDomain(java.lang.Object domainObject)` Loads the contents of this object from the given object.
`void` | `loadFromOriginal()` Loads this object from its original in the domain if it has one, otherwise clear the object.
`void` | `loadMGraphFromDomain(Refinement refinement)`
`IXObject` | `makeBaseObject()` Makes an empty object of the right class that can represent this UIObject in the domain.
`java.util.List` | `makeSequence()`
`boolean` | `matchesPattern(LList pattern)`
`void` | `moveToUIDomain(UIDomain uiDomain)` Move the object from its current UIDomain to the given one.
`boolean` | `nameHasChanged(java.lang.Object nameThing)` Determines whether the object's identifying fields have changed
`void` | `noteChange()` Get the UIDomain to note the change of this object
`boolean` | `orderingsAreSequential()` Checks whether the orderings are a sequence of the nodes.
`boolean` | `orderingsAreSequential(java.util.Collection orderings)`
`static java.util.List` | `parseIssues(UIDomain uiDomain, java.lang.String sIssues)` Builds a LList of nodes from a string that contains node descriptions.
`static java.util.List` | `parseNodes(UIDomain uiDomain, java.lang.String expansion)` Builds a LList of nodes from a string that contains node descriptions.
`java.lang.String` | `print()`
`void` | `removeDataChangeListener(DataChangeListener l)`
`void` | `removeFromDomain()`
`void` | `removeFromDomain(Domain domain)` Removes the object's corresponding base object from the domain.
`void` | `removeGraph(IGraph g)`
`boolean` | `sameNodes(java.util.List nodes, java.util.List otherNodes)`
`boolean` | `sameValue(java.lang.String field, java.lang.Object value, java.lang.Object otherValue)` Determines whether the two given values of the given field differ
`void` | `saveCanvasPositionGraphToDomain(Refinement refinement)`
`void` | `saveMGraphToDomain(Refinement refinement)`
`void` | `saveToDomain()` Saves this object into a suitable baseObject.
`void` | `saveToDomain(java.lang.Object domainObject)` Saves the contents of this object into the given object.
`void` | `setAnnotations(Annotations annotations)`
`void` | `setAutoPoints(java.util.List points)`
`void` | `setBaseObject(IXObject object)` Sets the object that will represent this one in the domain.
`void` | `setBaseReference(java.lang.Object ref)` Sets the Id that can be used to identify the base object in the domain.
`void` | `setComments(java.lang.String comments)`
`void` | `setConditions(java.util.List conditions)`
`void` | `setConstraints(java.util.List cs)`
`void` | `setGraph(IGraph g)`
`void` | `setIssues(java.util.List issues)`
`void` | `setLegalName(java.lang.String name)`
`void` | `setName(java.lang.String newName)`
`void` | `setNodes(java.util.List nodes)`
`void` | `setOrderings(java.util.List orderings)`
`void` | `setOrderingType(java.lang.String type)` Sets the refinement's ordering type (none, parallel, sequence, other) if it is allowed to.
`void` | `setOtherConstraints(java.util.List constraints)`
`void` | `setPattern(LList pattern)`
`void` | `setTypeConstraint(ItemVar var, Constraint constraint)`
`void` | `setTypeConstraints(java.util.List typeConstrs)`
`boolean` | `setValue(java.lang.String field, java.lang.Object value)` Sets the given field to the given value.
`void` | `setVariableConstraints(ItemVar var, java.util.List varConstrs)` Replace all Find all previous (world-state) constraints that have the given variable in them with the given ones.
`void` | `setVariableDeclarations(java.util.List vars)`
`static boolean` | `similarPattern(LList patternOne, LList patternTwo)`
`void` | `updateInDomain()`
`void` | `updateInDomain(Domain domain)` Updates the base object in the domain with the contents of this object.
`void` | `updateNodes(java.util.List nodes)`
`void` | `updateOrderings()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### name

    public java.lang.String name

### pattern

    public LList pattern

### nodes

    public java.util.List nodes

### orderings

    public java.util.List orderings

### constraints

    public java.util.List constraints

### issues

    public java.util.List issues

### comments

    public java.lang.String comments

### variableDeclarations

    public java.util.List variableDeclarations

### annotations

    public Annotations annotations

### uiDomain

    protected UIDomain uiDomain

### baseObject

    protected Refinement baseObject

### baseReference

    protected java.lang.String baseReference

### graph

    protected IGraph graph

  name of the original refinement

### autoPoints

    protected java.util.List autoPoints

Constructor Detail

### UIRefinement

    public UIRefinement(UIDomain uiDomain)

### UIRefinement

    public UIRefinement(UIDomain uiDomain,
                        Refinement original)

Method Detail

### cloneThis

    public UIRefinement cloneThis()

### getName

    public java.lang.String getName()

  Specified by:
    `getName` in interface `Named`

### setName

    public void setName(java.lang.String newName)

  Specified by:
    `setName` in interface `UIObject`

### setLegalName

    public void setLegalName(java.lang.String name)

### getPattern

    public LList getPattern()

### setPattern

    public void setPattern(LList pattern)

### clearPattern

    public void clearPattern()

### getNodes

    public java.util.List getNodes()

### setNodes

    public void setNodes(java.util.List nodes)

### updateNodes

    public void updateNodes(java.util.List nodes)

### clearNodes

    public void clearNodes()

### getOrderings

    public java.util.List getOrderings()

### setOrderings

    public void setOrderings(java.util.List orderings)

### clearOrderings

    public void clearOrderings()

### updateOrderings

    public void updateOrderings()

### getConstraints

    public java.util.List getConstraints()

### setConstraints

    public void setConstraints(java.util.List cs)

### clearConstraints

    public void clearConstraints()

### deleteConstraint

    public boolean deleteConstraint(Constraint c)

  Removes the given constraint;

  Returns:
    true if the constraint was removed, false if it was not a constraint in the list. ***********Why no fire change!?

### getConditions

    public java.util.List getConditions()

### setConditions

    public void setConditions(java.util.List conditions)

### getTypeConstraints

    public java.util.List getTypeConstraints()

### setTypeConstraints

    public void setTypeConstraints(java.util.List typeConstrs)

### getTypeConstraint

    public Constraint getTypeConstraint(ItemVar var)

### setTypeConstraint

    public void setTypeConstraint(ItemVar var,
                                  Constraint constraint)

### getVariableConstraints

    public java.util.List getVariableConstraints(ItemVar var)

  Find all (world-state) constraints that have the given variable in them. return@ a list of world-state constraints

### setVariableConstraints

    public void setVariableConstraints(ItemVar var,
                                       java.util.List varConstrs)

  Replace all Find all previous (world-state) constraints that have the given variable in them with the given ones.

### filterForConditions

    public static java.util.List filterForConditions(java.util.List constraints)

  Gets the list of conditions and effects that are in the constraints.

  Parameters:
    `constraints` - a list of constraint objects that may contain conditions or effects.
  Returns:
    conditions/effects only

### filterForVariable

    public static java.util.List filterForVariable(ItemVar var,
                                                   java.util.List constraints)

  Searches the given constraints for ones that constrain the variable, i.e. pattern assignments that have the variable as their subject. E.g. looking for ?x constraints: (name ?x = "fred") fits but not (friend ?p = ?x)

  Parameters:
    `var` - the variable to be constrained
    `constraints` - a list of constraints that may contain variable constraints.
  Returns:
    a list of variable constraints

### getOtherConstraints

    public java.util.List getOtherConstraints()

### setOtherConstraints

    public void setOtherConstraints(java.util.List constraints)

### hasOrderings

    public boolean hasOrderings()

### hasConditions

    public boolean hasConditions()

### hasAnonConstraints

    public boolean hasAnonConstraints()

### getIssues

    public java.util.List getIssues()

### setIssues

    public void setIssues(java.util.List issues)

### deleteIssue

    public void deleteIssue(Issue issue)

### clearIssues

    public void clearIssues()

### getComments

    public java.lang.String getComments()

### setComments

    public void setComments(java.lang.String comments)

### getAnnotations

    public Annotations getAnnotations()

### setAnnotations

    public void setAnnotations(Annotations annotations)

### getDomain

    public Domain getDomain()

  Description copied from interface: `UIObject`
  Gets the base domain.

  Specified by:
    `getDomain` in interface `UIObject`

### getUIDomain

    public UIDomain getUIDomain()

  Description copied from interface: `UIObject`
  Gets the ui domain of which this object is part.

  Specified by:
    `getUIDomain` in interface `UIObject`

### moveToUIDomain

    public void moveToUIDomain(UIDomain uiDomain)

  Description copied from interface: `UIObject`
  Move the object from its current UIDomain to the given one.

  Specified by:
    `moveToUIDomain` in interface `UIObject`

### getBaseReference

    public java.lang.Object getBaseReference()

  Description copied from interface: `UIObject`
  Gets the Id that can be used to identify the base object in the domain.

  Specified by:
    `getBaseReference` in interface `UIObject`

### setBaseReference

    public void setBaseReference(java.lang.Object ref)

  Description copied from interface: `UIObject`
  Sets the Id that can be used to identify the base object in the domain.

  Specified by:
    `setBaseReference` in interface `UIObject`

### getBaseObject

    public IXObject getBaseObject()

  Description copied from interface: `UIObject`
  Gets the object that corresponds to this one in the domain.

  Specified by:
    `getBaseObject` in interface `UIEditableObject`
  Specified by:
    `getBaseObject` in interface `UIObject`

### makeBaseObject

    public IXObject makeBaseObject()

  Description copied from interface: `UIObject`
  Makes an empty object of the right class that can represent this UIObject in the domain.

  Specified by:
    `makeBaseObject` in interface `UIObject`

### setBaseObject

    public void setBaseObject(IXObject object)

  Description copied from interface: `UIObject`
  Sets the object that will represent this one in the domain.

  Specified by:
    `setBaseObject` in interface `UIObject`

### getBaseClass

    public java.lang.Class getBaseClass()

  Description copied from interface: `UIObject`
  Gets the class of objects that can represent this one in the domain.

  Specified by:
    `getBaseClass` in interface `UIObject`

### hasOriginal

    public boolean hasOriginal()

  Description copied from interface: `UIObject`
  Determines whether the object has an original in the base domain.

  Specified by:
    `hasOriginal` in interface `UIEditableObject`
  Specified by:
    `hasOriginal` in interface `UIObject`

### saveToDomain

    public void saveToDomain()

  Saves this object into a suitable baseObject. Does not add the base object to the domain.

  Specified by:
    `saveToDomain` in interface `UIObject`

### saveToDomain

    public void saveToDomain(java.lang.Object domainObject)

  Description copied from interface: `UIObject`
  Saves the contents of this object into the given object.

  Specified by:
    `saveToDomain` in interface `UIObject`

### loadFromDomain

    public void loadFromDomain()

  Loads this object from its baseObject. ***Think about undoing this!!

  Specified by:
    `loadFromDomain` in interface `UIObject`

### getVariableDeclarations

    public java.util.List getVariableDeclarations()

### setVariableDeclarations

    public void setVariableDeclarations(java.util.List vars)

### getVariablesUsed

    public java.util.SortedSet getVariablesUsed()

### loadFromDomain

    public void loadFromDomain(java.lang.Object domainObject)

  Description copied from interface: `UIObject`
  Loads the contents of this object from the given object. The given object should be of the right class (same as the result of getBaseClass()).

  Specified by:
    `loadFromDomain` in interface `UIObject`

### saveMGraphToDomain

    public void saveMGraphToDomain(Refinement refinement)

### saveCanvasPositionGraphToDomain

    public void saveCanvasPositionGraphToDomain(Refinement refinement)

### loadMGraphFromDomain

    public void loadMGraphFromDomain(Refinement refinement)

### loadCanvasPositionGraphFromDomain

    public void loadCanvasPositionGraphFromDomain(Refinement refinement)

### graphFromPosition

    public IGraph graphFromPosition(Refinement refinement,
                                    java.lang.Object pos)

### getOriginal

    public IXObject getOriginal()

  Description copied from interface: `UIObject`
  Gets the object that corresponds to this one in the original domain.

  Specified by:
    `getOriginal` in interface `UIObject`

### loadFromOriginal

    public void loadFromOriginal()

  Loads this object from its original in the domain if it has one, otherwise clear the object. Replaces the base-object with a fresh clone of the original or with a new base-object.

  Specified by:
    `loadFromOriginal` in interface `UIObject`

### sameNodes

    public boolean sameNodes(java.util.List nodes,
                             java.util.List otherNodes)

### addToDomain

    public void addToDomain()

### addToDomain

    public void addToDomain(Domain domain)

  Description copied from interface: `UIObject`
  Adds the contents of this UIObject to the domain (part of publish).

  Specified by:
    `addToDomain` in interface `UIObject`

### updateInDomain

    public void updateInDomain()
                        throws DomainReferenceException

  Throws:
    `DomainReferenceException`

### updateInDomain

    public void updateInDomain(Domain domain)
                        throws DomainReferenceException

  Description copied from interface: `UIObject`
  Updates the base object in the domain with the contents of this object.

  Specified by:
    `updateInDomain` in interface `UIObject`
  Throws:
    `DomainReferenceException`

### removeFromDomain

    public void removeFromDomain()
                          throws DomainReferenceException

  Throws:
    `DomainReferenceException`

### removeFromDomain

    public void removeFromDomain(Domain domain)
                          throws DomainReferenceException

  Description copied from interface: `UIObject`
  Removes the object's corresponding base object from the domain.

  Specified by:
    `removeFromDomain` in interface `UIObject`
  Throws:
    `DomainReferenceException`

### noteChange

    public void noteChange()

  Get the UIDomain to note the change of this object

  Specified by:
    `noteChange` in interface `UIObject`

### isUndefined

    public boolean isUndefined()

  A refinement is undefined if all its data fields are empty except the pattern which may have data in it.

  Specified by:
    `isUndefined` in interface `UIEditableObject`

### isEmpty

    public boolean isEmpty()

  A refinement is empty if all its data fields are empty. Note: the refinement may not have started out as empty - check whether it has a base-object for full emptiness.

  Specified by:
    `isEmpty` in interface `UIEditableObject`
  Specified by:
    `isEmpty` in interface `UIObject`

### isEmpty

    public boolean isEmpty(Refinement refinement)

  A refinement is empty if all its data fields are empty. Note: the refinement may not have started out as empty - check whether it has a base-object for full emptiness.

### hasChanged

    public boolean hasChanged()

  Finds out whether the refinement has changed from the base-object (i.e. since the object was last saved to draft).

  Specified by:
    `hasChanged` in interface `UIEditableObject`
  Specified by:
    `hasChanged` in interface `UIObject`

### collectChanges

    public java.util.List collectChanges(Refinement original)

  Collects the differences between this object and the given one.

  Returns:
    a list of strings describing changes

### collectChanges

    public java.util.List collectChanges(Refinement original,
                                         java.lang.String which)

### collectChanges

    public java.util.List collectChanges()

  Collects the differences between this object and the base one.

  Specified by:
    `collectChanges` in interface `UIObject`
  Returns:
    a list of strings describing changes

### collectChangesFromOriginal

    public java.util.List collectChangesFromOriginal()

  Collects the differences between this object and the base one.

  Specified by:
    `collectChangesFromOriginal` in interface `UIObject`
  Returns:
    a list of strings describing changes

### hasChangedNoDebug

    public boolean hasChangedNoDebug(Refinement original)

  Finds out whether the refinement has changed from the given object. The refinement has not changed if the fields have not changed. The refinement's fields are: name, pattern, nodes, orderings, constraints, issues, comments The refinement has also not changed if the original is null and it is empty.

### hasChanged

    public boolean hasChanged(Refinement original)

  Finds out whether the refinement has changed from the given object. The refinement has not changed if the fields have not changed. The refinement's fields are: name, pattern, nodes, orderings, constraints, issues, comments The refinement has also not changed if the original is null and it is empty.

### hasChangedFromOriginal

    public boolean hasChangedFromOriginal()

  Finds out whether the refinement has changed from the original. The refinement has not changed if there is an original (baseReference) and the refinement's fields have not changed. The refinement's fields are: name, pattern, nodes, orderings, constraints, issues, annotations

  Specified by:
    `hasChangedFromOriginal` in interface `UIEditableObject`
  Specified by:
    `hasChangedFromOriginal` in interface `UIObject`

### nameHasChanged

    public boolean nameHasChanged(java.lang.Object nameThing)

  Description copied from interface: `UIObject`
  Determines whether the object's identifying fields have changed

  Specified by:
    `nameHasChanged` in interface `UIObject`

### sameValue

    public boolean sameValue(java.lang.String field,
                             java.lang.Object value,
                             java.lang.Object otherValue)

  Description copied from interface: `UIObject`
  Determines whether the two given values of the given field differ

  Specified by:
    `sameValue` in interface `EditableObject`
  Specified by:
    `sameValue` in interface `UIObject`

### setValue

    public boolean setValue(java.lang.String field,
                            java.lang.Object value)

  Description copied from interface: `UIObject`
  Sets the given field to the given value. Should default to UIUtil.setObjectFieldValue(Object object, String field, Class fieldClass, Object value).

  Specified by:
    `setValue` in interface `EditableObject`
  Specified by:
    `setValue` in interface `UIObject`

### checkConsistency

    public void checkConsistency()

### parseNodes

    public static java.util.List parseNodes(UIDomain uiDomain,
                                            java.lang.String expansion)

  Builds a LList of nodes from a string that contains node descriptions.

  Parameters:
    `expansion` - a string containing node descriptions (patterns) seperated by new lines.
  Returns:
    a LList of Nodes.

### parseIssues

    public static java.util.List parseIssues(UIDomain uiDomain,
                                             java.lang.String sIssues)

  Builds a LList of nodes from a string that contains node descriptions.

  Parameters:
    `expansion` - a string containing node descriptions (patterns) seperated by new lines.
  Returns:
    a LList of Nodes.

### deleteNode

    public void deleteNode(NodeSpec node)

### deleteNodeConstraints

    protected void deleteNodeConstraints(NodeSpec node)

### matchesPattern

    public boolean matchesPattern(LList pattern)

### findNode

    public NodeSpec findNode(Name id)

### findNode

    public NodeSpec findNode(LList pattern)

  Tries to find a node within this refinement whose pattern matches the given pattern.

  Returns:
    the first node spec whose pattern matches the given pattern, null if none match.

### findNode

    public NodeSpec findNode(java.util.List nodeList,
                             LList pattern)

  Tries to find a node in the given list whose pattern matches the given pattern.

  Returns:
    the first node spec whose pattern matches the given pattern, null if none match.

### findEditedNode

    public static NodeSpec findEditedNode(java.util.List oldNodes,
                                          LList pattern)

  Tries to find a node in the given list with a similar pattern. Similar patterns are those that ***.

  Returns:
    the first node spec whose pattern is similar to the given pattern, null if none are similar.

### similarPattern

    public static boolean similarPattern(LList patternOne,
                                         LList patternTwo)

### constraintMentionsNode

    public static boolean constraintMentionsNode(Constraint c,
                                                 Name nodeId)

### constraintMentionsNode

    public static boolean constraintMentionsNode(Ordering o,
                                                 Name nodeId)

### getNewNodeId

    public Name getNewNodeId()

### getHighestNodeId

    public Name getHighestNodeId()

### getHighestNodeId

    public static Name getHighestNodeId(java.util.List nodes)

### addNode

    public void addNode(NodeSpec node)

### addIssue

    public void addIssue(Issue issue)

### addConstraint

    public void addConstraint(java.lang.Object newValue)
                       throws UIRefinement.ConstraintTypeException

  Throws:
    `UIRefinement.ConstraintTypeException`

### addOrdering

    public void addOrdering(Constraint newValue)

### addOrdering

    public void addOrdering(Ordering newValue)

### getOrderingType

    public java.lang.String getOrderingType()

  Gets the refinement's ordering type (none, parallel, sequence, other).

  Returns:
    - none (undecided) if there are less than two nodes
    - parallel if there are no orderings an 2 or more nodes
    - sequence if there are 2 or more nodes and they are in sequence
    - other otherwise.

### getOrderingType

    public java.lang.String getOrderingType(java.util.Collection orderings)

### setOrderingType

    public void setOrderingType(java.lang.String type)

  Sets the refinement's ordering type (none, parallel, sequence, other) if it is allowed to.

### orderingsAreSequential

    public boolean orderingsAreSequential()

  Checks whether the orderings are a sequence of the nodes.

### orderingsAreSequential

    public boolean orderingsAreSequential(java.util.Collection orderings)

### makeSequence

    public java.util.List makeSequence()

### isRef

    public static boolean isRef(NodeSpec node,
                                java.lang.Object o)

  Check whether the given object is a reference to the given node. checks equals on node, node's toString, node's pattern for NodeSpec refs checks node/ref's id, node/ref's pattern for NodeEndRef checks isRef on ref's node

### print

    public java.lang.String print()

  Specified by:
    `print` in interface `UIObject`

### addDataChangeListener

    public void addDataChangeListener(DataChangeListener l)

  Specified by:
    `addDataChangeListener` in interface `EditableObject`

### removeDataChangeListener

    public void removeDataChangeListener(DataChangeListener l)

  Specified by:
    `removeDataChangeListener` in interface `EditableObject`

### setGraph

    public void setGraph(IGraph g)

### getGraph

    public IGraph getGraph()

### removeGraph

    public void removeGraph(IGraph g)

### setAutoPoints

    public void setAutoPoints(java.util.List points)

### children

    public java.util.Enumeration children()

  Specified by:
    `children` in interface `javax.swing.tree.TreeNode`

### getAllowsChildren

    public boolean getAllowsChildren()

  Specified by:
    `getAllowsChildren` in interface `javax.swing.tree.TreeNode`

### getChildAt

    public javax.swing.tree.TreeNode getChildAt(int index)

  Specified by:
    `getChildAt` in interface `javax.swing.tree.TreeNode`

### getChildCount

    public int getChildCount()

  Specified by:
    `getChildCount` in interface `javax.swing.tree.TreeNode`

### getIndex

    public int getIndex(javax.swing.tree.TreeNode node)

  Specified by:
    `getIndex` in interface `javax.swing.tree.TreeNode`

### getParent

    public javax.swing.tree.TreeNode getParent()

  Specified by:
    `getParent` in interface `javax.swing.tree.TreeNode`

### isLeaf

    public boolean isLeaf()

  Specified by:
    `isLeaf` in interface `javax.swing.tree.TreeNode`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD